<?php
    error_reporting(0);
    ini_set('log_errors', 0);
    ini_set('display_errors', 0);


    const aNVersion = '3.3.0';
    const CheckerVersion = '1.0.0';


    //Requirements
    const REQ_PHP_VERSION = '8.2.0';
    const REQ_DISK_FREE_SPACE = '500';
    const REQ_DATABASE_INFO = 'MySQL 5.7 or MariaDB 10.1';
    const REQ_MEMORY_LIMIT = '256';
    const REQ_MAX_EXECUTION_TIME = '30';
    const REQ_MAX_INPUT_TIME = '30';
    const REQ_POST_MAX_SIZE = '4';
    const REQ_UPLOAD_MAX_FILESIZE = '2';

    $checkExtension = array();
    $checkExtension[] = array('extName'=>'curl');
    $checkExtension[] = array('extName'=>'zip');
    $checkExtension[] = array('extName'=>'dom');
    $checkExtension[] = array('extName'=>'libxml');
    $checkExtension[] = array('extName'=>'fileinfo');
    $checkExtension[] = array('extName'=>'exif');
    $checkExtension[] = array('extName'=>'json');
    $checkExtension[] = array('extName'=>'pdo');
    $checkExtension[] = array('extName'=>'pdo_mysql');
    $checkExtension[] = array('extName'=>'simplexml');
    $checkExtension[] = array('extName'=>'xml');
    $checkExtension[] = array('extName'=>'zlib');



?>

<!DOCTYPE html>
<html lang="de">
<head>
    <meta charset="UTF-8">
    <title>alphaNEXT - Pre Installation Check</title>

    <style>
        body {
            margin: 0;
            padding: 0;
            font-family: Arial, sans-serif;
            background-color: #f2f2f2;
        }
        header {
            display: flex;
            justify-content: space-between;
            align-items: center;
            background-color: #fff;
            padding: 20px;
            box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.2);
        }
        main {
            display: flex;
            justify-content: center;
            align-items: center;
            margin-top: 50px;
            margin-bottom:75px;
        }
        p.version {
            font-size: 12px;
            color: #b2b2b2;
        }
        .box {
            position: relative;
            width: 60%;
            height: 100%;
            min-height: 600px;
            background-color: #fff;
            box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.2);
            overflow: hidden;
        }
        .box_headline {
            border-bottom: 1px solid #b6b6b6;
        }
        .box_headline h1 {
            font-size: 20px;
            font-weight: normal;
            color: #0578BE;
            padding: 1em 2em 0em 2em;
        }
        .box_headline p {
            font-size: 13px;
            font-weight: normal;
            color: #000;
            padding: 1em 2em 0em 2em;
        }
        .box .box_wizzard {
            padding: 1em 2em 1em 2em;
            display: block;
            word-break: break-word;
            width: auto;
        }

        .container {
            display: flex;
            align-items: center;
            margin-bottom: 10px;
        }
        .resultCircle_ok {
            width: 35px;
            height: 35px;
            background-color: green;
            border-radius: 50%;
            color: #FFF;
            text-align: center;
            font-size: 13px;
            line-height: 35px;
            display: inline-block;
            overflow: hidden;
        }
        .resultCircle_error {
            width: 35px;
            height: 35px;
            background-color: red;
            border-radius: 50%;
            color: #FFF;
            text-align: center;
            line-height: 35px;
            font-size: 13px;
            display: inline-block;
            overflow: hidden;
        }
        .resultCircle_noTest {
            width: 35px;
            height: 35px;
            background-color: #0d89f5;
            border-radius: 50%;
            color: #FFF;
            text-align: center;
            line-height: 35px;
            font-size: 13px;
            display: inline-block;
            overflow: hidden;
        }
        .resultCircle_info {
            width: 35px;
            height: 35px;
            background-color: grey;
            border-radius: 50%;
            color: #FFF;
            text-align: center;
            line-height: 35px;
            font-size: 13px;
            display: inline-block;
            overflow: hidden;
        }

        .resultText {
            margin-left: 10px;
            font-size: 15px;
        }
        .resultRequiresInfo {
            font-size: 12px;
            text-decoration: underline;
        }

        footer {
            display: flex;
            justify-content: space-between;
            align-items: center;
            background-color: #fff;
            padding: 20px;
            box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.2);
            position: fixed;
            bottom: 0;
            left: 0;
            right: 0;
        }
        footer p {
            font-size: 14px;
            color: #3f3f3f;
            margin: 0;
        }
    </style>
</head>
<body>
<header>
    <p class="version">alphaNEXT Version: <?php echo aNVersion; ?></p>
    <p class="version">Pre Check Version: <?php echo CheckerVersion; ?></p>
</header>
<main>
    <div class="box">
        <div class="box_headline">
            <h1>alphaNEXT - Pre Installation Check</h1>
            <p>The following checks whether your web server or web hosting meets the requirements for alphaNEXT. Please note that the following tests refer to the alphaNEXT version mentioned above. If an option could not be verified or the test did not pass, you should manually verify this option before installing alphaNEXT.</p>
            <p>More informations about alphaNEXT on: <a href="https://www.alphanext.de" target="_blank">alphanext.de</a></p>
        </div>

        <div class="box_wizzard">
            <?php
                $ausgabe = '';


                //##### DIRECTORY CHECK #####//
                $ausgabe .= '<div class="container">';
                try {
                    $directory = '/';
                    $permissions = @decoct(fileperms($directory));
                    if (empty($permissions)){
                        $permissions = 'N/A';
                    }

                    if (@is_writable($directory)){
                        $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                        $ausgabe .= '<span class="resultText"> Directory write permission<br /><small class="resultRequiresInfo">Is required! Current permissions: '.$permissions.'</small></span>';
                    } else {
                        $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                        $ausgabe .= '<span class="resultText"> Directory write permission<br /><small class="resultRequiresInfo">Permissions: '.$permissions.'</small></span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> Directory write permission: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### DIRECTORY CHECK #####//


                //##### HTTP/HTTPS #####//
                $ausgabe .= '<div class="container">';
                try {
                    if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') {
                        $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                        $ausgabe .= '<span class="resultText"> HTTPS support</span>';
                    } else {
                        $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                        $ausgabe .= '<span class="resultText"> HTTPS support<br /><small class="resultRequiresInfo">SSL certificate is highly recommended!</small></span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> HTTPS support: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### HTTP/HTTPS #####//


                //##### PHP VERSION #####//
                $ausgabe .= '<div class="container">';
                try {
                    if (@str_replace('.', '', PHP_VERSION) < REQ_PHP_VERSION){
                        $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                        $ausgabe .= '<span class="resultText"> PHP-Version: '.PHP_VERSION.'<br /><small class="resultRequiresInfo">Requires: PHP '.REQ_PHP_VERSION.'</small></span>';
                    } else {
                        $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                        $ausgabe .= '<span class="resultText"> PHP-Version: '.PHP_VERSION.'</span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> PHP-Version: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### PHP VERSION #####//


                //##### DATABASE #####//
                $ausgabe .= '<div class="container">';
                $ausgabe .= '<span class="resultCircle_info">i</span>';
                $ausgabe .= '<span class="resultText"> Database: <small>Test not possible!</small><br /><small class="resultRequiresInfo">Requires: '.REQ_DATABASE_INFO.'</small></span>';
                $ausgabe .= '</div>';
                //##### DATABASE #####//


                //##### DISC SPACE #####//
                $ausgabe .= '<div class="container">';
                try {
                    $diskSpaceBytes = @disk_free_space('/');
                    $diskSpaceMB = @round($diskSpaceBytes / 1024 / 1024, 2);

                    if (!empty($diskSpaceMB)){
                        if ($diskSpaceMB >= REQ_DISK_FREE_SPACE){
                            $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                            $ausgabe .= '<span class="resultText"> Disk Free Space: '.$diskSpaceMB.' MB</span>';
                        } else {
                            $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                            $ausgabe .= '<span class="resultText"> Disk Free Space: '.$diskSpaceMB.' MB<br /><small class="resultRequiresInfo">Requires: '.REQ_DISK_FREE_SPACE.' MB</small></span>';
                        }
                    } else {
                        $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                        $ausgabe .= '<span class="resultText"> Disk Free Space: <small>Test not possible!</small></span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> Disk Free Space: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### DISC SPACE #####//


                //##### memory_limit #####//
                $ausgabe .= '<div class="container">';
                try {
                    $memory_limit = @ini_get('memory_limit');

                    if ($memoryLimit !== false && $memoryLimit !== '') {
                        if (@str_replace('M', '', $memory_limit) < REQ_MEMORY_LIMIT) {
                            $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                            $ausgabe .= '<span class="resultText"> memory_limit: ' . $memory_limit . '<br /><small class="resultRequiresInfo">Requires: ' . REQ_MEMORY_LIMIT . ' M</small></span>';
                        } else {
                            $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                            $ausgabe .= '<span class="resultText"> memory_limit: ' . $memory_limit . '</span>';
                        }
                    } else {
                        $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                        $ausgabe .= '<span class="resultText"> memory_limit: <small>Test not possible!</small></span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> memory_limit: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### memory_limit #####//


                //##### max_execution_time #####//
                $ausgabe .= '<div class="container">';
                try {
                    $max_execution_time = @ini_get('max_execution_time');

                    if ($max_execution_time !== false && $max_execution_time !== '') {
                        if (@str_replace('M', '', $max_execution_time) < REQ_MAX_EXECUTION_TIME) {
                            $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                            $ausgabe .= '<span class="resultText"> max_execution_time: ' . $max_execution_time . '<br /><small class="resultRequiresInfo">Requires: ' . REQ_MAX_EXECUTION_TIME . '</small></span>';
                        } else {
                            $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                            $ausgabe .= '<span class="resultText"> max_execution_time: ' . $max_execution_time . '</span>';
                        }
                    } else {
                        $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                        $ausgabe .= '<span class="resultText"> max_execution_time: <small>Test not possible!</small></span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> max_execution_time: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### max_execution_time #####//


                //##### max_input_time #####//
                $ausgabe .= '<div class="container">';
                try {
                    $max_input_time = @ini_get('max_input_time');

                    if ($max_input_time !== false && $max_input_time !== '') {
                        if (@str_replace('M', '', $max_input_time) < REQ_MAX_INPUT_TIME) {
                            $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                            $ausgabe .= '<span class="resultText"> PHP max_input_time: ' . $max_input_time . '<br /><small class="resultRequiresInfo">Requires: ' . REQ_MAX_INPUT_TIME . '</small></span>';
                        } else {
                            $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                            $ausgabe .= '<span class="resultText"> max_input_time: ' . $max_input_time . '</span>';
                        }
                    } else {
                        $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                        $ausgabe .= '<span class="resultText"> max_input_time: <small>Test not possible!</small></span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> max_input_time: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### max_input_time #####//


                //##### post_max_size #####//
                $ausgabe .= '<div class="container">';
                try {
                    $post_max_size = @ini_get('post_max_size');

                    if ($post_max_size !== false && $post_max_size !== '') {
                        if (@str_replace('M', '', $post_max_size) < REQ_POST_MAX_SIZE) {
                            $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                            $ausgabe .= '<span class="resultText"> PHP post_max_size: ' . $post_max_size . '<br /><small class="resultRequiresInfo">Requires: ' . REQ_POST_MAX_SIZE . ' M</small></span>';
                        } else {
                            $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                            $ausgabe .= '<span class="resultText"> post_max_size: ' . $post_max_size . '</span>';
                        }
                    } else {
                        $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                        $ausgabe .= '<span class="resultText"> post_max_size: <small>Test not possible!</small></span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> post_max_size: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### post_max_size #####//


                //##### upload_max_filesize #####//
                $ausgabe .= '<div class="container">';
                try {
                    $upload_max_filesize = @ini_get('upload_max_filesize');

                    if ($upload_max_filesize !== false && $upload_max_filesize !== '') {
                        if (@str_replace('M', '', $upload_max_filesize) < REQ_UPLOAD_MAX_FILESIZE) {
                            $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                            $ausgabe .= '<span class="resultText"> PHP upload_max_filesize: ' . $upload_max_filesize . '<br /><small class="resultRequiresInfo">Requires: ' . REQ_UPLOAD_MAX_FILESIZE . ' M</small></span>';
                        } else {
                            $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                            $ausgabe .= '<span class="resultText"> upload_max_filesize: ' . $upload_max_filesize . '</span>';
                        }
                    } else {
                        $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                        $ausgabe .= '<span class="resultText"> upload_max_filesize: <small>Test not possible!</small></span>';
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> upload_max_filesize: <small>Test not possible!</small></span>';
                }
                $ausgabe .= '</div>';
                //##### upload_max_filesize #####//



                //##### PHP EXTENSIONS #####//
                try {
                    if (!empty($checkExtension) && is_array($checkExtension)){
                        if (count($checkExtension)>=1) {
                            foreach ($checkExtension as $ext) {
                                if (!empty($ext['extName'])) {
                                    $ausgabe .= '<div class="container">';
                                    if (@extension_loaded($ext['extName'])) {
                                        $ausgabe .= '<span class="resultCircle_ok">OK</span>';
                                        $ausgabe .= '<span class="resultText"> PHP Extension ['.$ext['extName'].']</span>';
                                    } else {
                                        $ausgabe .= '<span class="resultCircle_error">ERR</span>';
                                        $ausgabe .= '<span class="resultText"> PHP Extension ['.$ext['extName'].']<br /><small class="resultRequiresInfo">Is required!</small></span>';
                                    }
                                    $ausgabe .= '</div>';
                                }
                            }
                        }
                    }
                } catch (Exception $e) {
                    $ausgabe .= '<span class="resultCircle_noTest">?</span>';
                    $ausgabe .= '<span class="resultText"> PHP Extensions: <small>Test not possible!</small></span>';
                }
                //##### PHP EXTENSIONS #####//



                echo $ausgabe;
            ?>
        </div>

    </div>
</main>
<footer>
    <p>&copy; <?php echo date('Y');?> alphaNEXT</p>
</footer>

<script>


</script>
</body>
</html>
